#define USE_KERNEL
#define USE_TI89
#define USE_TI92P

#include <genlib.h>
#include <extgraph.h>

// Compile with : tigcc -O2 -Wall Bench.c extgraph.a genlib.a

///////////////////////////////////////////////////////////////////////////////////////
#include "_X_Constantes.h"
#include "_X_Plane.h"
#include "_X_PxlPut.h"
#include "_X_Sprite_16x.h"              // _X_Lib
//#include "_X_Sprite_8x.h"
#include "_X_Lib.h"
#include "_X_Lib_MACRO.h"
///////////////////////////////////////////////////////////////////////////////////////

unsigned short spritedata[] =
	 {0xaaaa,0x5555,0xaaaa,0x5555,0xaaaa,0x5555,0xaaaa,0x5555,
	 0xaaaa,0x5555,0xaaaa,0x5555,0xaaaa,0x5555,0xaaaa,0x5555};
BGS bgs16 = {16, 1};
SPRITE_16 spr16[1] =
	{{
	0xffff,0xffff,
	0xcccd,0xffff,
	0xb333,0xffff,
	0xb333,0xffff,
	0xcccd,0xffff,
	0xcccd,0xffff,
	0xb333,0xffff,
	0xb333,0xffff,
	0xcccd,0xffff,
	0xcccd,0xffff,
	0xb333,0xffff,
	0xb333,0xffff,
	0xcccd,0xffff,
	0xcccd,0xffff,
	0xb333,0xffff,
	0xffff,0xffff}};
short	modes[4]   = {COLOR_LIGHTGRAY,COLOR_DARKGRAY,COLOR_BLACK,COLOR_WHITE};
SCR_RECT full = {0,0,239,127};
BITMAP bmp = {32,32};
BGS bgs32 = {32, 2, 0};
BGS bgs64 = {64, 4, 0};
POINT P1 = {10,10}, P2 = {150,20}, P3 = {30,90};

void _main(void)
	{
	PUSH_DSCREEN(DSCREEN *Scr);		// DScreen + Adress of the DScreen 
	short	i, j, x, y;
	volatile short xv, yv, z;
	unsigned short spritedata3[16];
	unsigned long count ;
		
	// The limits are declared as volatile to avoid some biais, because of the optimisation of TiGcc.
	// The way of rendering of theses sprites is very linear, and could be optimized.
	// That's why I don't want that Tiggc optimizes it.
	yv = 100-16;		// Max Y
	xv = 160-16;		// Max X
	z = 0;

	//Init GENLIB
	gl_init();
	gl_set_dscreen_function(Scr);
	gl_set_dscreen_int(Scr);
	gl_cls();
	gl_set_spr_xy(0, 0);
	gl_set_spr_tile(spr16);
	
	// Init XGLib
		// Hard patch so that XGLib uses the allocated DSCREEN 
		// Instead of XGOn()
		tigcc0=(void *) LIGHT_SCREEN(Scr); 
		tigcc1=(void *) DARK_SCREEN(Scr); 
	XGPlanc(XNewGPlan());

	// Line Bench
        count = 0;
	gl_timer = 0;
        for (j=0;j<4;j++) {
            short used_color = modes[j];
            for (i=0;  i<160;i++) count++,DrawGrayLine2B(80,50,i,8,   used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
            for (i=8;  i<100;i++) count++,DrawGrayLine2B(80,50,159,i, used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
            for (i=159;i>=0; i--) count++,DrawGrayLine2B(80,50,i,99,  used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
            for (i=99; i>=8; i--) count++,DrawGrayLine2B(80,50,0,i,   used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
        }
	glaux_text(0,0,C_BLACK,T_LARGE,"AMS : %ld Line/s", 90*count/gl_timer);
	// Extgraph
        count = 0;
        gl_timer = 0;
        for (j=0;j<4;j++) {
            short used_color = modes[j];
            for (i=0;  i<160;i++) count++,FastDrawGrayLine2B(80,50,i,8,   used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
            for (i=8;  i<100;i++) count++,FastDrawGrayLine2B(80,50,159,i, used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
            for (i=159;i>=0; i--) count++,FastDrawGrayLine2B(80,50,i,99,  used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
            for (i=99; i>=8; i--) count++,FastDrawGrayLine2B(80,50,0,i,   used_color,LIGHT_SCREEN(Scr),DARK_SCREEN(Scr));
        }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT : %ld Line/s", 90*count/gl_timer);
	// GenLib
	count = 0;
        gl_timer = 0;
        for (j=1;j<=4;j++) {
            short used_color = j & 3;
            for (i=0;  i<160;i++) count++,gl_draw_line(80,50,i,8,   used_color);
            for (i=8;  i<100;i++) count++,gl_draw_line(80,50,159,i, used_color);
            for (i=159;i>=0; i--) count++,gl_draw_line(80,50,i,99,  used_color);
            for (i=99; i>=8; i--) count++,gl_draw_line(80,50,0,i,   used_color);
        }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN : %ld Line/s", 90*count/gl_timer);
	gl_wait_a_key();
	
	// Sprite16 Bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<yv;y++)
	 for (x=0;x<xv;x++)
	  {
           count++;
           Sprite16(x,y,16,spritedata,DARK_SCREEN(Scr),SPRT_AND);
           Sprite16(x,y,16,spritedata,DARK_SCREEN(Scr),SPRT_OR);
           Sprite16(x,y,16,spritedata,LIGHT_SCREEN(Scr),SPRT_AND);
           Sprite16(x,y,16,spritedata,LIGHT_SCREEN(Scr),SPRT_OR);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GCC Spr16: %ld Spr/s", 90*count/gl_timer);
	gl_wait_a_key();
	// ExtGraph
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<yv;y++)
         for (x=0;x<xv;x++)
          {
           count++;
           GraySprite16_MASK(x, y, 16, spritedata, spritedata,
           	spritedata, spritedata, DARK_SCREEN(Scr),LIGHT_SCREEN(Scr));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT : %ld Spr/s", 90*count/gl_timer);
	gl_wait_a_key();
	// XGLib
	XClrGPlan();
	count = 0;
	gl_timer = 0;
	for (y=0;y<yv;y++)
         for (x=0;x<xv;x++)
          {
           count++;
	   XGFSpriteM16x16(x,y, spritedata);
          }
	XCpyGPlanToLCD();		// This function must be inside the counting loop, to avoid a biais
	glaux_text(0,0,C_BLACK,T_LARGE,"X %ld Spr16/s", 90*count/gl_timer);
	gl_wait_a_key();
	// XGLib 2
	XClrGPlan();
	count = 0;
	gl_timer = 0;
	for (y=-40;y<yv+40;y++)
         for (x=-40;x<xv+40;x++)
          {
           count++;
           if (x>-32 && x< (240+32-16) && (y>-32) && y<(128+32-16))		// Clipping
		XGFSpriteM16x16(x, y, (unsigned char *) spritedata + 64*z);	// Indirection
          }
	XCpyGPlanToLCD();		// This function must be inside the counting loop, to avoid a biais
	glaux_text(0,0,C_BLACK,T_LARGE,"X %ld Spr16/s+Clip+Ind", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=-40;y<yv+40;y++)
         for (x=-40;x<xv+40;x++)
          {
           count++;
           gl_put_sprite_16(x,y,z);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Spr16/s+ind+clip: ", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<yv;y++)
         for (x=0;x<xv;x++)
          {
           count++;
           gl_put_big_sprite(x, y, &bgs16);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld bgs16+mask+clip", 90*count/gl_timer);
	gl_wait_a_key();
	
	// Sprite32 bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-32;y+=8)
         for (x=0;x<160-32;x++)
          {
           count++;
           PortSet(DARK_SCREEN(Scr),239,127);
           BitmapPut(x,y,&bmp, &full, A_AND);
           BitmapPut(x,y,&bmp, &full, A_OR);
           PortSet(LIGHT_SCREEN(Scr),239,127);
           BitmapPut(x,y,&bmp, &full, A_AND);
           BitmapPut(x,y,&bmp, &full, A_OR);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"AMS %ld Bmp32+Clip", 90*count/gl_timer);
	gl_wait_a_key();
	// ExtGraph
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-32;y++)
         for (x=0;x<160-32;x++)
          {
           count++;
	   GraySprite32_MASK(x, y, 32,
	   	 spritedata, spritedata, spritedata, spritedata,
	   	 DARK_SCREEN(Scr), LIGHT_SCREEN(Scr));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld Spr32/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-32;y++)
         for (x=0;x<160-32;x++)
          {
           count++;
	   gl_put_big_sprite(x, y, &bgs32);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Spr32/s+Clip+Mask", 90*count/gl_timer);
	gl_wait_a_key();

	// Sprite 64 bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-64;y+=2)
         for (x=0;x<200-64;x++)
          {
           count++;
	   GraySpriteX8_MASK(x, y, 64,
	   	 spritedata, spritedata, spritedata, spritedata, 64/8,
	   	 DARK_SCREEN(Scr), LIGHT_SCREEN(Scr));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld Spr64/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-64;y++)
         for (x=0;x<200-64;x++)
          {
           count++;
	   gl_put_big_sprite(x, y, &bgs64);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Spr64/s+Clip+Mask", 90*count/gl_timer);
	gl_wait_a_key();

	// Circle bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
	  {
           count++;
	   PortSet(DARK_SCREEN(Scr),239,127);
	   DrawClipEllipse(160/2,100/2,y,y,&full,A_NORMAL);
	   PortSet(LIGHT_SCREEN(Scr),239,127);
	   DrawClipEllipse(160/2,100/2,y,y,&full,A_NORMAL);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"AMS %ld Circle/s+Clip", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
	  {
           count++;
	   gl_draw_clipped_circle(160/2,100/2,y,3);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Circle/s+clip", 90*count/gl_timer);
	gl_wait_a_key();

	// Mirror Bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-16;y+=4)
         for (x=0;x<160-16;x++)
          {
           count++;
	   SpriteX8_MIRROR_H(16, spritedata, 2, spritedata3); // Plane 1
	   SpriteX8_MIRROR_H(16, spritedata, 2, spritedata3); // Plane 2
	   SpriteX8_MIRROR_H(16, spritedata, 2, spritedata3); // Mask
           GraySprite16_MASK(x, y, 16, spritedata3, spritedata3,
           	spritedata3, spritedata3, DARK_SCREEN(Scr),LIGHT_SCREEN(Scr));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld Spr16-Mirror/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-16;y++)
         for (x=0;x<160-16;x++)
          {
           count++;
           gl_put_sprite_16_flip_h(x,y,0);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Spr16+Mirror+Clip+Ind", 90*count/gl_timer);
	gl_wait_a_key();
	
	// Scale Bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-64;y+=8)
         for (x=0;x<160-64;x+=4)
          {
           count++;
	   ScaleSprite32_OR(spritedata, DARK_SCREEN(Scr), x, y, 64, 64);
	   ScaleSprite32_OR(spritedata, LIGHT_SCREEN(Scr), x, y, 64, 64);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld Scale 32->64/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-64;y++)
         for (x=0;x<160-64;x++)
          {
           count++;
           gl_put_big_sprite_zoom(x,y,&bgs32, 2*65536, 2*65536);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Scale 32->64/s", 90*count/gl_timer);
	gl_wait_a_key();

	// String Bench
	FontSetSys(F_6x8);
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-8;y+=4)
         for (x=0;x<160-64;x++)
          {
           count++;
	   DrawGrayStr2B(x,y, "ExtGraph is good", A_NORMAL, DARK_SCREEN(Scr), LIGHT_SCREEN(Scr));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld String/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100-8;y++)
         for (x=0;x<160-64;x++)
          {
           count++;
           gl_put_medium_string(DARK_SCREEN(Scr), x, y, "Genlib is Good.");
           gl_put_medium_string(LIGHT_SCREEN(Scr), x, y, "Genlib is Good.");
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld String/s", 90*count/gl_timer);
	gl_wait_a_key();
	
	// TriangleBench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
          {
          	count++;
		PortSet(DARK_SCREEN(Scr), 239, 127);
          	FillTriangle(10,10,150,20,30, y, &full, A_NORMAL);
		PortSet(LIGHT_SCREEN(Scr), 239, 127);
          	FillTriangle(10,10,150,20,30, y, &full, A_NORMAL);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"AMS %ld Triangle/s+Clip", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
          {
           count++;
           P3.y = y;
 	   gl_draw_clipped_c_face(&P1, &P2, &P3, 3);
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Triangle+Clip", 90*count/gl_timer);
	gl_wait_a_key();


	// Clear Bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<1000;y++)
          {
          	count++;
		ClearGrayScreen2B(LIGHT_SCREEN(Scr), DARK_SCREEN(Scr));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld Clear/s", 90*count/gl_timer);
	gl_wait_a_key();
	// XGLib
	XClrGPlan();
	count = 0;
	gl_timer = 0;
	for (y=0;y<1000;y++)
          {
           count++;
		XClrGPlan();
          }
	XCpyGPlanToLCD();		// This function must be inside the counting loop, to avoid a biais
	glaux_text(0,0,C_BLACK,T_LARGE,"X %ld Clear/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<1000;y++)
          {
           count++;
	   gl_cls();
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld Clear/s", 90*count/gl_timer);
	gl_wait_a_key();
	

	// Pixel Bench
	
	// Extgraph
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
	 for(x = 0 ; x < 160 ; x++) 
          {
          	count++;
		EXT_SETPIX(LIGHT_SCREEN(Scr), x, y);
		EXT_SETPIX(DARK_SCREEN(Scr), x, y);		
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld LinearPixel/s", 90*count/gl_timer);
	gl_wait_a_key();
	// XGLib
	XClrGPlan();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
	 for(x = 0 ; x < 160 ; x++) 
          {
          	count++;
		XPxlDPut(x,y);
          }
	XCpyGPlanToLCD();		// This function must be inside the counting loop, to avoid a biais
	glaux_text(0,0,C_BLACK,T_LARGE,"X %ld LinearPixel/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	for (y=0;y<100;y++)
	 for(x = 0 ; x < 160 ; x++) 
          {
           count++;
	   gl_put_pixel(x,y,3);		// Fixe gen.h
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld LinearPixel/s", 90*count/gl_timer);
	gl_wait_a_key();



	// Random Pixel Bench
	gl_cls();
	count = 0;
	gl_timer = 0;
	for(i = 0 ; i < 30000 ; i++)
          {
		x = random(240);
		y = random(128);
		if (x >= 0 && x < 240 && y>= 0 && y < 128)
			switch (random(4))
				{
				case 0:
					EXT_CLRPIX(LIGHT_SCREEN(Scr), x, y);
					EXT_CLRPIX(DARK_SCREEN(Scr), x, y);
					break;
				case 1:
					EXT_SETPIX(LIGHT_SCREEN(Scr), x, y);
					EXT_CLRPIX(DARK_SCREEN(Scr), x, y);
					break;
				case 2:
					EXT_CLRPIX(LIGHT_SCREEN(Scr), x, y);
					EXT_SETPIX(DARK_SCREEN(Scr), x, y);
					break;
				default:
					EXT_SETPIX(LIGHT_SCREEN(Scr), x, y);
					EXT_SETPIX(DARK_SCREEN(Scr), x, y);
				}
          	count++;
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"EXT %ld RandomClipPixel/s", 90*count/gl_timer);
	gl_wait_a_key();
	// XGLib
	XClrGPlan();
	count = 0;
	gl_timer = 0;
	for(i = 0 ; i < 30000 ; i++)
          {
          	count++;
		x = random(240);
		y = random(128);
		if (x >= 0 && x < 240 && y>= 0 && y < 128)
		   	XPxlPut(x, y, random(4));
          }
	XCpyGPlanToLCD();		// This function must be inside the counting loop, to avoid a biais
	glaux_text(0,0,C_BLACK,T_LARGE,"X %ld RandomClipPixel/s", 90*count/gl_timer);
	gl_wait_a_key();
	// GenLib
	gl_cls();
	count = 0;
	gl_timer = 0;
	 for(i = 0 ; i < 30000 ; i++) 
          {
           count++;
	   gl_put_pixel(random(240), random(128), random(4));
          }
	glaux_text(0,0,C_BLACK,T_LARGE,"GEN %ld RandomClipPixel/s", 90*count/gl_timer);
	gl_wait_a_key();

	// The end
	PortRestore();
	gl_quit();
}

