// Genlib snake example

#define OPTIMIZE_ROM_CALLS
#include "genlib.h"

#define WY (88/4)
#define WX (160/4)

enum {
  Void, Right, Up, Left,
  Down, Dot, Wall
};

void big_pix(int x, int y, int c)
{
  x *= 4;
  y *= 4;
  glaux_rect(x,y+10,x+3,y+13,c,0,C_NONE);
}

void new_dot(char world[][WX])
{
  int x,y;

  do {
    x = random(WX);
    y = random(WY);
  } while(world[y][x]);

  world[y][x] = Dot;
  big_pix(x,y,C_DGRAY);
}

void _main(void)
{
  gl_init();

  // init dscreen
  ALLOC_DSCREEN(dscr);
  gl_set_dscreen_int(dscr);
  gl_set_dscreen_function(dscr);
  gl_cls();

  glaux_text(0,0,C_BLACK,T_LARGE,"SNAKE");

  int i;
  for(i=1; i<4; i++)
    glaux_rect(i,i+10,WX*4-1-i,WY*4+9-i,C_NONE,1,i);


  char world[WY][WX];
  memset(world, 0, WX*WY);

  for(i=0; i<WX; i++)
    world[0][i] = world[WY-1][i] = Wall;

  for(i=0; i<WY; i++)
    world[i][0] = world[i][WX-1] = Wall;

  new_dot(world);

  int score = 0;
  int dir = Right;
  int size_inc = 5;
  int hdx, hdy, tlx, tly;
  int ldir, t;
  JOYPAD j;

  hdx=hdy=tlx=tly=10;

  do {
    ldir = dir;
    t = 200;

    while(--t)
    {
      j = gl_read_joypad();
      if(!j.right_key && ldir!=Left)
        dir = Right;
      if(!j.left_key && ldir!=Right)
        dir = Left;
      if(!j.up_key && ldir!=Down)
        dir = Up;
      if(!j.down_key && ldir!=Up)
        dir = Down;
    }

    world[hdy][hdx] = dir;
    switch(dir)
    {
      case Right: hdx++; break;
      case Left: hdx--; break;
      case Down: hdy++; break;
      case Up: hdy--;
    }

    t = world[hdy][hdx];
    if(t==Dot)
    {
      size_inc = 5;
      new_dot(world);
    }
    else if(t)
      break;

    big_pix(hdx,hdy,C_BLACK);

    if(size_inc)
    {
      size_inc--;
      score++;
    }
    else
    {
      t = world[tly][tlx];
      world[tly][tlx] = 0;
      big_pix(tlx,tly,C_WHITE);
      switch(t)
      {
        case Right: tlx++; break;
        case Left: tlx--; break;
        case Down: tly++; break;
        case Up: tly--;
      }
    }
    glaux_text(136,0,C_BLACK,T_LARGE,"%03d",score);
  } while(j.exit_key);

  gl_wait_no_key();
  gl_quit();
}
